상담사가 Google 지도 또는 날씨 API와 같은 외부 도구를 인증할 수 있도록 하려면 상담사 ID 인증 관리자에서 API 키 인증 제공업체를 사용하여 아웃바운드 인증을 구성하세요.
API 키 인증 제공자는 암호화 키를 관리합니다. 이 기능을 사용하면 에이전트의 코드에 키를 하드코딩하거나 수동으로 관리할 필요가 없습니다.
API 키 워크플로
API 키 인증 제공자는 에이전트의 ID를 사용하며 사용자 동의가 필요하지 않습니다. Google에서는 저장 중에 API 키를 보호하기 위한 조치를 취합니다. 에이전트 개발 키트 (ADK)를 사용하면 API 키가 자동으로 검색되어 도구 호출 헤더에 삽입됩니다.
시작하기 전에
- 올바른 인증 방법을 선택했는지 확인합니다.
Agent Identity Connector API를 사용 설정합니다.
API 사용 설정에 필요한 역할
API를 사용 설정하려면
serviceusage.services.enable권한이 포함된 서비스 사용량 관리자 IAM 역할(roles/serviceusage.serviceUsageAdmin)이 필요합니다. 역할 부여 방법 알아보기연결하려는 서드 파티 서비스에서 API 키를 가져옵니다.
필요한 역할
API 키 인증 제공자를 만들고 사용하는 데 필요한 권한을 얻으려면 관리자에게 프로젝트에 대한 다음 IAM 역할을 부여해 달라고 요청하세요.
-
인증 제공업체를 만들려면 다음 단계를 따르세요.
- IAM 커넥터 관리자 (
roles/iamconnectors.admin) - IAM 커넥터 편집자 (
roles/iamconnectors.editor)
- IAM 커넥터 관리자 (
-
인증 제공업체를 사용하려면 다음 단계를 따르세요.
- IAM 커넥터 사용자 (
roles/iamconnectors.user) - Vertex AI 사용자 (
roles/aiplatform.user) - 서비스 사용량 소비자(
roles/serviceusage.serviceUsageConsumer)
- IAM 커넥터 사용자 (
역할 부여에 대한 자세한 내용은 프로젝트, 폴더, 조직에 대한 액세스 관리를 참조하세요.
이러한 사전 정의된 역할에는 API 키 인증 제공자를 만들고 사용하는 데 필요한 권한이 포함되어 있습니다. 필요한 정확한 권한을 보려면 필수 권한 섹션을 펼치세요.
필수 권한
API 키 인증 제공자를 만들고 사용하려면 다음 권한이 필요합니다.
-
인증 제공업체를 만들려면
iamconnectors.connectors.create권한이 필요합니다. -
인증 제공업체를 사용하려면 다음 단계를 따르세요.
-
iamconnectors.connectors.retrieveCredentials -
aiplatform.endpoints.predict -
aiplatform.sessions.create
-
커스텀 역할이나 다른 사전 정의된 역할을 사용하여 이 권한을 부여받을 수도 있습니다.
서드 파티 서비스에서 API 키 가져오기
인증 제공업체를 만들기 전에 에이전트가 연결할 서드 파티 서비스에서 API 키를 가져옵니다.
Google Cloud외부의 서드 파티 서비스에 연결하는 경우 해당 서비스의 개발자 포털에서 API 키를 가져와 이 섹션의 단계를 건너뛰세요.
Google Cloud 서비스 (예: Cloud Translation 또는 Google 지도)에 연결하는 경우 다음 단계를 실행하여 API 키를 생성하고 구성할 수 있습니다.
-
Google Cloud 콘솔에서 프로젝트에 필요한 API 서비스를 사용 설정합니다.
- Google Cloud 콘솔에서 API 및 서비스 >라이브러리 페이지로 이동합니다.
- 에이전트가 사용하는 API(예: Cloud Translation API 또는 Google Maps Weather API)를 검색하여 사용 설정합니다.
- 생성된 API 키 문자열을 복사합니다.
API 키를 구성합니다.
- Google Cloud 콘솔에서 API 및 서비스 >사용자 인증 정보 페이지로 이동합니다.
- 사용자 인증 정보 만들기 >API 키를 클릭합니다.
- API 키 만들기 대화상자에서 다음을 실행합니다.
- API 키의 고유한 이름을 입력합니다.
- 사용 설정한 특정 API로 키를 제한하려면 API 제한 선택 목록에서 해당 API를 선택합니다.
- 선택사항: 보안 위험을 줄이기 위해 키를 제한하세요 섹션에서 액세스를 제한할 애플리케이션 유형을 선택합니다.
- 만들기를 클릭합니다.
-
서비스 엔드포인트에 테스트 요청을 전송하여 API 키를 검증합니다.
-
Cloud Translation API 키를 확인하려면 다음 명령어를 실행합니다.
curl -X POST \ -H "Content-Type: application/json" \ -H "X-goog-api-key:
YOUR_API_KEY" \ -d '{"q": "Hello world", "target": "es"}' \ "https://translation.googleapis.com/language/translate/v2"YOUR_API_KEY를 생성한 API 키로 바꿉니다. -
Google Maps Weather API 키를 확인하려면 다음 명령어를 실행하세요.
curl -X GET \ "https://weather.googleapis.com/v1/currentConditions:lookup?key=
YOUR_API_KEY&location.latitude=37.4220&location.longitude=-122.0841"YOUR_API_KEY를 생성한 API 키로 바꿉니다.
API 키가 유효하고 올바르게 구성된 경우 서비스는 요청된 데이터를 반환합니다.
-
API 키 인증 제공업체 만들기
인증 제공자를 만들어 서드 파티 애플리케이션의 구성과 사용자 인증 정보를 정의합니다.
API 키 인증 제공자를 만들려면 Google Cloud 콘솔 또는 Google Cloud CLI를 사용하세요.
콘솔
- Google Cloud 콘솔에서 Agent Registry 페이지로 이동합니다.
- 인증 제공자를 만들 에이전트의 이름을 클릭합니다.
- ID를 클릭합니다.
- 인증 제공업체 섹션에서 인증 제공업체 추가를 클릭합니다.
-
인증 제공업체 추가 창에서 이름과 설명을 입력합니다.
이름에는 소문자, 숫자 또는 하이픈만 포함할 수 있으며, 하이픈으로 끝나면 안 되고 소문자로 시작해야 합니다.
- OAuth 유형 목록에서 API 키를 선택합니다.
- 만들고 계속하기를 클릭합니다.
- 인증 제공자를 사용할 수 있는 권한을 에이전트 ID에 부여하려면 액세스 권한 부여를 클릭합니다.
이렇게 하면 인증 제공업체 리소스의 에이전트 ID에 커넥터 사용자(
roles/iamconnectors.user) 역할이 자동으로 할당됩니다. - 인증 제공업체 사용자 인증 정보 섹션에 API 키를 입력합니다.
- 공급업체 구성 추가를 클릭합니다.
새로 생성된 인증 제공자가 인증 제공자 목록에 표시됩니다.
Google Cloud CLI
-
인증 제공업체를 만듭니다.
gcloud alpha agent-identity connectors create
AUTH_PROVIDER_NAME\ --project="PROJECT_ID" \ --location="LOCATION" \ --api-key="API_KEY" - 인증 제공업체가 목록에 표시되고 상태가
ENABLED인지 확인합니다.gcloud alpha agent-identity connectors list \ --project="
PROJECT_ID" \ --location="LOCATION" -
에이전트와 로컬 개발 환경이 인증 제공자에서 사용자 인증 정보를 가져올 수 있도록 액세스 권한을 부여합니다. 배포된 에이전트와 개인 사용자 계정이 인증 제공업체에 액세스하도록 허용하려면 인증 제공업체 리소스에 커넥터 사용자(
roles/iamconnectors.user) 역할을 부여하세요.-
배포된 에이전트의 SPIFFE ID (에이전트 ID)에 대한 액세스 권한을 부여합니다.
gcloud alpha agent-identity connectors add-iam-policy-binding
AUTH_PROVIDER_NAME\ --project="PROJECT_ID" \ --location="LOCATION" \ --role="roles/iamconnectors.user" \ --member="principal://agents.global.org-ORGANIZATION_ID.system.id.goog/resources/aiplatform/projects/PROJECT_NUMBER/locations/LOCATION/reasoningEngines/ENGINE_ID" -
로컬 개발 및 테스트를 위해 개인 사용자 계정에 액세스 권한을 부여합니다(
adk web).gcloud alpha agent-identity connectors add-iam-policy-binding
AUTH_PROVIDER_NAME\ --project="PROJECT_ID" \ --location="LOCATION" \ --role="roles/iamconnectors.user" \ --member="user:USER_EMAIL"
-
다음을 바꿉니다.
PROJECT_ID: Google Cloud 프로젝트 ID입니다.LOCATION: 인증 제공업체와 에이전트가 배포된 위치입니다 (예:us-west1).AUTH_PROVIDER_NAME: 인증 제공업체의 이름입니다 (예:bigquery-mcp-3lo-authprovider).AUTHORIZATION_URL: 승인 서버 URL (예:https://accounts.google.com/o/oauth2/v2/auth)입니다.TOKEN_URL: 토큰 서버 URL (예:https://oauth2.googleapis.com/token)입니다.CLIENT_ID: 서드 파티 서비스에서 생성한 OAuth 클라이언트 IDCLIENT_SECRET: 서드 파티 서비스에서 생성한 OAuth 클라이언트 보안 비밀번호입니다.ORGANIZATION_ID: Google Cloud 조직 ID입니다.PROJECT_NUMBER: Google Cloud 프로젝트 번호.ENGINE_ID: 배포된 추론 엔진 에이전트의 ID입니다.USER_EMAIL: 개인 사용자 계정 이메일 주소입니다.
에이전트 코드에서 인증
에이전트를 인증하려면 ADK를 사용하면 됩니다.
ADK
ADK의 MCP 도구 세트를 사용하여 에이전트의 코드에서 인증 제공자를 참조합니다.
from google.adk.agents.llm_agent import LlmAgent from google.adk.auth.credential_manager import CredentialManager from google.adk.integrations.agent_identity import GcpAuthProvider, GcpAuthProviderScheme from google.adk.tools.mcp_tool.mcp_session_manager import StreamableHTTPConnectionParams from google.adk.tools.mcp_tool.mcp_toolset import McpToolset from google.adk.auth.auth_tool import AuthConfig # Register the Google Cloud auth provider so the CredentialManager can use it. CredentialManager.register_auth_provider(GcpAuthProvider()) # Create the Google Cloud auth provider scheme using the auth provider's full resource name. auth_scheme = GcpAuthProviderScheme( name="projects/PROJECT_ID/locations/LOCATION/connectors/AUTH_PROVIDER_NAME" ) # Configure an MCP tool with the authentication scheme. toolset = McpToolset( connection_params=StreamableHTTPConnectionParams(url="https://YOUR_MCP_SERVER_URL"), auth_scheme=auth_scheme, ) # Initialize the agent with the authenticated tools. agent = LlmAgent( name="AGENT_NAME", model="gemini-2.5-flash", instruction="AGENT_INSTRUCTIONS", tools=[toolset], )
예: Google 지도 MCP에 연결
다음 예에서는 에이전트를 Google 지도 MCP 서버에 연결하는 agent.py 구성을 보여줍니다.
import os from google.adk.agents import Agent from google.adk.apps import App from google.adk.auth.credential_manager import CredentialManager from google.adk.integrations.agent_identity import GcpAuthProvider, GcpAuthProviderScheme from google.adk.models import Gemini from google.adk.tools.mcp_tool.mcp_session_manager import StreamableHTTPConnectionParams from google.adk.tools.mcp_tool.mcp_toolset import McpToolset os.environ["GOOGLE_CLOUD_PROJECT"] = "PROJECT_ID" os.environ["GOOGLE_GENAI_USE_VERTEXAI"] = "True" # Register GCP auth provider for Agent Identity Credentials service CredentialManager.register_auth_provider(GcpAuthProvider()) maps_auth_scheme = GcpAuthProviderScheme( name="projects/PROJECT_ID/locations/LOCATION/connectors/AUTH_PROVIDER_NAME" ) maps_tools = McpToolset( connection_params=StreamableHTTPConnectionParams(url="https://mapstools.googleapis.com/mcp"), auth_scheme=maps_auth_scheme, errlog=None, ) root_agent = Agent( name="root_agent", model=Gemini(model="gemini-2.5-flash"), instruction="You are a helpful AI assistant designed to provide accurate and useful information. You can also use your Google Maps tools to look up locations and directions.", tools=[maps_tools], ) app = App( root_agent=root_agent, name="AGENT_NAME", )
ADK
ADK에서 인증된 함수 도구를 사용하여 에이전트의 코드에서 인증 제공업체를 참조합니다.
import httpx from google.adk.agents.llm_agent import LlmAgent from google.adk.auth.credential_manager import CredentialManager from google.adk.integrations.agent_identity import GcpAuthProvider from google.adk.integrations.agent_identity import GcpAuthProviderScheme from google.adk.apps import App from google.adk.auth.auth_credential import AuthCredential from google.adk.auth.auth_tool import AuthConfig from google.adk.tools.authenticated_function_tool import AuthenticatedFunctionTool from vertexai import agent_engines # First, register Google Cloud auth provider CredentialManager.register_auth_provider(GcpAuthProvider()) # Create Auth Config spotify_auth_config = AuthConfig( auth_scheme=GcpAuthProviderScheme( name="projects/PROJECT_ID/locations/LOCATION/connectors/AUTH_PROVIDER_NAME" ) ) # Use the Auth Config in Authenticated Function Tool spotify_search_track_tool = AuthenticatedFunctionTool( func=spotify_search_track, auth_config=spotify_auth_config ) # Sample function tool async def spotify_search_track(credential: AuthCredential, query: str) -> str | list: token = None if credential.http and credential.http.credentials: token = credential.http.credentials.token if not token: return "Error: No authentication token available." async with httpx.AsyncClient() as client: response = await client.get( "https://api.spotify.com/v1/search", headers={"Authorization": f"Bearer {token}"}, params={"q": query, "type": "track", "limit": 1}, ) # Add your own logic here agent = LlmAgent( name="AGENT_NAME", model="gemini-2.5-flash", instruction="AGENT_INSTRUCTIONS", tools=[spotify_search_track_tool], ) app = App( name="APP_NAME", root_agent=agent, ) vertex_app = agent_engines.AdkApp(app_name=app)
예: Google Maps Weather API에 연결
다음 예에서는 인증된 함수 도구를 사용하여 에이전트를 Google 지도 Weather API에 연결하는 agent.py 구성을 보여줍니다.
import os import httpx from google.adk.agents import Agent from google.adk.apps import App from google.adk.auth.auth_credential import AuthCredential from google.adk.auth.auth_tool import AuthConfig from google.adk.auth.credential_manager import CredentialManager from google.adk.integrations.agent_identity import GcpAuthProvider, GcpAuthProviderScheme from google.adk.models import Gemini from google.adk.tools.authenticated_function_tool import AuthenticatedFunctionTool os.environ["GOOGLE_CLOUD_PROJECT"] = "PROJECT_ID" os.environ["GOOGLE_GENAI_USE_VERTEXAI"] = "True" # Register GCP auth provider for Agent Identity Credentials service CredentialManager.register_auth_provider(GcpAuthProvider()) weather_auth_config = AuthConfig( auth_scheme=GcpAuthProviderScheme( name="projects/PROJECT_ID/locations/LOCATION/connectors/AUTH_PROVIDER_NAME" ) ) async def get_weather(credential: AuthCredential, latitude: float, longitude: float) -> str | dict: """Gets the current weather conditions for a location using latitude and longitude.""" api_key = None if http := credential.http: if http.additional_headers and "X-GOOG-API-KEY" in http.additional_headers: api_key = http.additional_headers["X-GOOG-API-KEY"] elif http.credentials and http.credentials.token: api_key = http.credentials.token if not api_key: return "Error: No API key available from the auth provider." params = {"location.latitude": latitude, "location.longitude": longitude, "key": api_key} async with httpx.AsyncClient() as client: response = await client.get( "https://weather.googleapis.com/v1/currentConditions:lookup", params=params, ) if response.status_code != 200: return f"Error from Weather API: {response.status_code} - {response.text}" return response.json() get_weather_tool = AuthenticatedFunctionTool( func=get_weather, auth_config=weather_auth_config ) root_agent = Agent( name="root_agent", model=Gemini(model="gemini-2.5-flash"), instruction="You are a helpful AI assistant. You will use your weather tool to look up current conditions.", tools=[get_weather_tool], ) app = App( root_agent=root_agent, name="AGENT_NAME", )
ADK
ADK의 에이전트 레지스트리 MCP 도구 세트를 사용하여 에이전트의 코드에서 인증 제공자를 참조합니다.
from google.adk.agents.llm_agent import LlmAgent from google.adk.auth.credential_manager import CredentialManager from google.adk.integrations.agent_identity import GcpAuthProvider from google.adk.integrations.agent_identity import GcpAuthProviderScheme from google.adk.tools.mcp_tool.mcp_session_manager import StreamableHTTPConnectionParams from google.adk.tools.mcp_tool.mcp_toolset import McpToolset from google.adk.auth.auth_tool import AuthConfig from google.adk.integrations.agent_registry import AgentRegistry # First, register Google Cloud auth provider CredentialManager.register_auth_provider(GcpAuthProvider()) # Create Google Cloud auth provider scheme by providing Auth Provider full resource name auth_scheme = GcpAuthProviderScheme( name="projects/PROJECT_ID/locations/LOCATION/connectors/AUTH_PROVIDER_NAME" ) # Set Agent Registry registry = AgentRegistry(project_id="PROJECT_ID", location="global") toolset = registry.get_mcp_toolset(mcp_server_name="projects/PROJECT_ID/locations/global/mcpServers/agentregistry-00000000-0000-0000-0000-000000000000", auth_scheme=auth_scheme) # Example MCP tool toolset = McpToolset( connection_params=StreamableHTTPConnectionParams(url="MCP_URL"), auth_scheme=auth_scheme, ) agent = LlmAgent( name="AGENT_NAME", model="MODEL_NAME", instruction="AGENT_INSTRUCTIONS", tools=[toolset], )
에이전트 배포
Google Cloud에 에이전트를 배포할 때는 에이전트 ID가 사용 설정되어 있어야 합니다.
Gemini Enterprise Agent Platform의 Agent Runtime에 배포하는 경우 identity_type=AGENT_IDENTITY 플래그를 사용하세요.
import vertexai
from vertexai import types
from vertexai.agent_engines import AdkApp
# Initialize the Vertex AI client with v1beta1 API for Agent Identity support
client = vertexai.Client(
project="PROJECT_ID",
location="LOCATION",
http_options=dict(api_version="v1beta1")
)
# Use the proper wrapper class for your Agent Framework (e.g., AdkApp)
app = AdkApp(agent=agent)
# Deploy the agent with Agent Identity enabled
remote_app = client.agent_engines.create(
agent=app,
config={
"identity_type": types.IdentityType.AGENT_IDENTITY,
"requirements": ["google-cloud-aiplatform[agent_engines,adk]", "google-adk[agent-identity]"],
},
)
다음 단계
- 에이전트 ID 인증 문제 해결
- 에이전트 ID 개요
- 인증 관리자로 3-legged OAuth를 사용하여 인증
- 인증 관리자로 2-legged OAuth를 사용하여 인증
- 에이전트 ID 인증 제공업체 관리